#include <sys/cdefs.h>

#include <stdio.h>

#include <test.h>
#include "internal.h"

#define	VERSION	"3.0"

//PRIVATESYM(one,TEST_3.0_PRIVATE)
__asm(".symver one,one@TEST_3.0_PRIVATE");
__attribute__((visibility("default")))
int one = 1;

//HIDDEN
__attribute__((visibility("hidden")))
long
i(long y, long d)
{
	printf("%s %s:%d i_long(%lx, %ld)\n", VERSION, __FILE__, __LINE__, y, d);
	return y + d;
}

//EXPORT
__attribute__((visibility("default")))
long
f(long x)
{
	printf("%s %s:%d f_long(%lx)\n", VERSION, __FILE__, __LINE__, x);
	return i(x << 8, one);
}

//HIDDEN
__attribute__((visibility("hidden")))
long
h(long x)
{
	printf("%s %s:%d h_long(%lx)\n", VERSION, __FILE__, __LINE__, x);
	return x >> 8;
}

//EXPORT
__attribute__((visibility("default")))
int
g(int x)
{
	printf("%s %s:%d g(%x)\n", VERSION, __FILE__, __LINE__, x);
	return h(f(x));
}
